=== debian/changelog ===
xgboost (1.2.1-1) unstable; urgency=medium

  * New upstream version 1.2.1
  * Specify B-D::librabit-dev version and apply wrap-and-sort.
  * Rebase/Refresh existing patches.
  * Specify minimal version of B-D::libdmlc-dev.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Mon, 26 Oct 2020 21:36:31 +0800

xgboost (1.2.0-1) experimental; urgency=medium

  * New upstream version 1.2.0
  * Add some basic autopkgtest files.
  * Refresh symbols control file.
  * Change maintainer mail address into debian-ai@l.d.o
  * Rebase the cmake.patch
  * Override lintianW "breakout-link" for python3-xgboost.
  * Specify Rules-Requires-Root: no.
  * Override a couple of lintianI and lintianW messages.
  * Assign the binary packages with the correct section info.

 -- Mo Zhou <lumin@debian.org>  Mon, 21 Sep 2020 15:54:52 +0800

xgboost (1.1.1-1) experimental; urgency=medium

  * Initial release. (Closes: #958072)

 -- Mo Zhou <lumin@debian.org>  Tue, 14 Jul 2020 22:34:43 +0800
