=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Scmake --with python3

execute_after_dh_auto_install:
	cd python-package; python3 setup.py install --install-layout=deb \
		--root=$(shell pwd)/debian/tmp/
	mkdir -p debian/tmp/usr/lib/python3/dist-packages/xgboost/lib/
	ln -s ../../../../$(DEB_HOST_MULTIARCH)/libxgboost.so.0 \
		debian/tmp/usr/lib/python3/dist-packages/xgboost/lib/libxgboost.so
