## xgboost 1.3.2.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 1.3.1.1
-Date: 2020-12-22
+Version: 1.3.2.1
+Date: 2021-01-14
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),
@@ -51,7 +51,7 @@
         (>= 1.5),
 RoxygenNote: 7.1.1
 SystemRequirements: GNU make, C++14
-Packaged: 2021-01-05 07:55:29 UTC; ubuntu
+Packaged: 2021-01-15 00:22:10 UTC; ubuntu
 Author: Tianqi Chen [aut],
   Tong He [aut, cre],
   Michael Benesty [aut],
@@ -70,4 +70,4 @@
   XGBoost contributors [cph] (base XGBoost implementation)
 Maintainer: Tong He <hetong007@gmail.com>
 Repository: CRAN
-Date/Publication: 2021-01-05 20:00:02 UTC
+Date/Publication: 2021-01-18 10:10:03 UTC
