## xgboost 1.4.1.1

=== DESCRIPTION ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Package: xgboost
 Type: Package
 Title: Extreme Gradient Boosting
-Version: 1.3.2.1
-Date: 2021-01-14
+Version: 1.4.1.1
+Date: 2021-04-22
 Authors@R: c(
   person("Tianqi", "Chen", role = c("aut"),
          email = "tianqi.tchen@gmail.com"),
@@ -45,13 +45,13 @@
 VignetteBuilder: knitr
 Suggests: knitr, rmarkdown, ggplot2 (>= 1.0.1), DiagrammeR (>= 0.9.0),
         Ckmeans.1d.dp (>= 3.3.1), vcd (>= 1.3), testthat, lintr, igraph
-        (>= 1.0.1), jsonlite, float, crayon, titanic
+        (>= 1.0.1), float, crayon, titanic
 Depends: R (>= 3.3.0)
 Imports: Matrix (>= 1.1-0), methods, data.table (>= 1.9.6), magrittr
-        (>= 1.5),
+        (>= 1.5), jsonlite (>= 1.0),
 RoxygenNote: 7.1.1
 SystemRequirements: GNU make, C++14
-Packaged: 2021-01-15 00:22:10 UTC; ubuntu
+Packaged: 2021-04-22 06:09:47 UTC; ubuntu
 Author: Tianqi Chen [aut],
   Tong He [aut, cre],
   Michael Benesty [aut],
@@ -70,4 +70,4 @@
   XGBoost contributors [cph] (base XGBoost implementation)
 Maintainer: Tong He <hetong007@gmail.com>
 Repository: CRAN
-Date/Publication: 2021-01-18 10:10:03 UTC
+Date/Publication: 2021-04-22 09:20:02 UTC
